"use strict";
// bling.js, because I want the $ of jQuery without jQuery
if(undefined===window.$){window.$=document.querySelectorAll.bind(document);
	[EventTarget.prototype,window,XMLHttpRequest.prototype].forEach(function setOnOff(p){
		Object.defineProperty(p,"on",{get(){return function onElement(t,f){this.addEventListener(t,f);return this;};}})
		Object.defineProperty(p,"off",{get(){return function offElement(t,f){this.removeEventListener(t,f);return this;};}});});
	[NodeList.prototype,HTMLCollection.prototype].forEach(function setOnArray(p){Object.setPrototypeOf(p,Array.prototype);
		Object.defineProperty(p,"on",{get(){return function onArray(t,f){this.forEach(function onEach(e){e.addEventListener(t,f);});return this;};}});
		Object.defineProperty(p,"off",{get(){return function offArray(t,f){this.forEach(function offEach(e){e.removeEventListener(t,f);});return this;};}});
});}
const toilet=new (function toilet(){
	// workaround for negated lookbehind, will simplify when better supported
	const matchCapsNoRepeats=(function(){try{return new RegExp("(?<!(?:: )|^)([A-Z])(?!\\1)([a-z \\d]*)","gu");}catch(x){return new RegExp("([A-Z])(?!\\1)([a-z \\d]+: [A-Z]+[a-z]+)?","gu");}})();
	const articleHeadings="html:lang(en) article>a.withFigure>figure>figcaption>h1,html:lang(en) .seeAlso .noFigure h1";
	const dynamicSelect="main>article p,main>article img";
	const staticSelect=".seeAlso p,.seeAlso img,.comment>p,article>iframe";
	const highResPixelDensity=1.2;
	var unfocustimer=null;
	function getSuggestions(e){
		const list=document.getElementById(e.target.dataset["list"]);
		const searchbox=e.target;
		searchbox.removeAttribute('list');
		if(undefined===searchbox.dataset.pending&&2<searchbox.value.length&&searchbox.size>=searchbox.value.length){
			const req=new XMLHttpRequest();
			const act=searchbox.closest("form").action;
			req.open("GET",act+"?suggestion="+searchbox.value);
			req.on("load",function fillSuggestions(r){
				if(200===req.status){
					const res=JSON.parse(req.response);
					if(0!==res.length){
						while(list.firstChild){
							list.removeChild(list.firstChild);
						}
						res.forEach(function add(s){
							const opt=document.createElement("option");
							opt.value=s;
							//opt.on("click",selectOption);
							list.appendChild(opt);
							const a=document.createElement("a");
							a.href=act+"?"+encodeURI(searchbox.name)+"="+encodeURI(s);
							a.textContent=s;
							opt.appendChild(a);
						});
						list.classList.add("show");
					}
				}
				if(searchbox.dataset.pending!=searchbox.value){
					delete searchbox.dataset.pending;
					getSuggestions(e);
				}else{
					delete searchbox.dataset.pending;
				}
			});
			searchbox.dataset.pending=searchbox.value;
			req.send();
		}
	}
	function searchFocus(e){
		if(unfocustimer){
			clearTimeout(unfocustimer);
			unfocustimer=null;
		}
		const list=document.getElementById(e.target.dataset["list"]);
		list.classList.add("show");
		const selected=list.querySelector(".selected");
		if(selected){
			selected.classList.remove("selected");
		}
	}
	function searchBlur(e){
		if(unfocustimer){
			clearTimeout(unfocustimer);
		}
		unfocustimer=setTimeout(function(){
			const list=document.getElementById(e.target.dataset["list"]).classList.remove("show");
		},4000);
	}
	function searchDown(e){
		const list=document.getElementById(e.target.dataset["list"]);
		const searchbox=e.target;
		var selected=list.querySelector(".selected");
		switch(e.keyCode){
			case 38:// up
				if(selected){
					const next=selected.previousElementSibling;
					next.classList.add("selected");
					selected.classList.remove("selected");
				}else{
					selected=list.lastElementChild;
					selected.classList.add("selected");
				}
				e.preventDefault();
				break;
			case 40:// down
				if(selected){
					const next=selected.nextElementSibling;
					next.classList.add("selected");
					selected.classList.remove("selected");
				}else{
					selected=list.firstElementChild;
					selected.classList.add("selected");
				}
				e.preventDefault();
				break;
			case 39:// right
				if(selected){
					searchbox.value=selected.value;
					e.preventDefault();
				}
				break;
			case 13:// enter
				if(selected){
					searchbox.value=selected.value;
				}
				break;
		}
	}
	/*function selectOption(e){
		const list=e.target.closest("datalist");
		const searchbox=document.getElementById(list.dataset["for"]);
		searchbox.value=e.target.value;
		searchbox.focus();
		const selected=list.querySelector(".selected");
		if(selected){
			selected.classList.remove("selected");
		}
		list.classList.remove("show");
		e.preventDefault();
	}*/
	function checkInputValidity(e){
		e.target.checkValidity();
	};
	function displayValidityMessage(e){
		if(e.target.validity.patternMismatch&&undefined!==e.target.dataset["patternmismatch"]){
			e.target.setCustomValidity(e.target.dataset["patternmismatch"]);
		}else if(e.target.validity.valueMissing&&undefined!==e.target.dataset["valuemissing"]){
			e.target.setCustomValidity(e.target.dataset["valuemissing"]);
		}else if(!e.target.validity.patternMismatch&&!e.target.validity.valueMissing){
			e.target.setCustomValidity("");
	}};
	function testTextarea(ta,regex){
		if(undefined!==regex&&undefined!==ta.dataset["patternmismatch"]&&!regex.test(ta.value)){
			ta.setCustomValidity(ta.dataset["patternmismatch"]);
			return false;
		}else if(ta.required&&ta.validity.valueMissing&&undefined!==ta.dataset["valuemissing"]){
			ta.setCustomValidity(ta.dataset["valuemissing"]);
			return false;
		}
		ta.setCustomValidity("");
		return true;
	};
	function setTextareaEvents(ta){
		const pattern=new RegExp(ta.dataset["pattern"],"u");
		ta.on("input",function testOnInput(e){testTextarea(e.target,pattern);}).on("invalid",function testOnInvalid(e){testTextarea(e.target,pattern);});
	};
	function testFormTextareas(e){
		const textareas=e.target.getElementsByTagName("textarea");
		for(var i=0;i<textareas.length;i++){
			const ta=textareas.item(i);
			if(!testTextarea(ta,new RegExp(ta.dataset["pattern"],"u"))){
				e.preventDefault();
				return false;
		}}
		return true;
	};
	function swapImagesIfNoticeable(e){
		const imgs=$("article>p>picture>img:not([data-swapped])");
		if(0===imgs.length){
			window.off("resize",swapImagesIfNoticeable);
		}else{
			imgs.forEach(function testImage(i){
				const p=i.closest("p");
				if(window.devicePixelRatio*p.clientWidth/i.width>=highResPixelDensity){
					if(960===i.width){
						i.attributes.removeNamedItem("width");
						i.attributes.removeNamedItem("height");
					}
					i.dataset.swapped=true;
			}});
	}};
	function sizeIframe(iFrame){
		iFrame.style.setProperty("width",'auto');
		const p=iFrame.parentElement.querySelector("article:not(:last-child)>p:last-of-type");
		if(undefined!==p){
			iFrame.style.setProperty("width",(p.clientWidth-1)+'px');
		}
		iFrame.style.setProperty("height",iFrame.contentWindow.document.body.scrollHeight+50+'px');
		return iFrame;
	};
	function getTextFromElements(root,selector){
		return root.querySelectorAll(selector).reduce(function getTextInReverseOrder(accum,e){
			switch(e.tagName){
				case "IFRAME":
					return null!==e.contentDocument.documentElement?e.contentDocument.documentElement.dataset.backgroundText+" "+accum:accum;
				case "IMG":
					return e.alt+" "+e.title+" "+accum;
				default:
					return e.textContent+" "+accum;
			}
			return accum;
		}," ");
	};
	function redoBackgroundText(e){
		if("background-text"===e.data){
			document.documentElement.dataset.backgroundText=(getTextFromElements(document,dynamicSelect)+getTextFromElements(document,staticSelect)).replace(/\s+/gum," ").trim();
		}else if("resize"===e.data){
			$("iframe").forEach(sizeIframe);
		}
	};
	function isLoaded(doc){return doc&&("complete"===doc.readyState);}
	function inIframe(){try{return window.self!==window.top;}catch(e){return true;}}
	function asideCollide(){
		if(900<$("html")[0].clientWidth){
			const aside=$("aside")[0];
			const asiderect=aside.getBoundingClientRect();
			const style=window.getComputedStyle(aside);
			$("aside+article li img").forEach(function checkImg(i){
				const rect=i.getBoundingClientRect();
				if(asiderect.bottom+Math.ceil(parseFloat(style.marginTop))+Math.ceil(parseFloat(style.marginBottom))+1>=rect.top){
					i.classList.add("asideCollide");
				}
			});
		}
	}
	function eagerLoad(){
		const img=$("img[loading='lazy']")[0];
		if(img){
			img.loading="eager";
			setTimeout(eagerLoad, 2000);
		}
	}
	this.flush=function flush(ready=false){
		if(0===$(".errorPage,.indexPage").length){
			const lc=$("#leftContent")[0];
			const aside=$("body>div>aside")[0];
			if(lc&&aside){
				const ref=$("#leftContent>*:not(.searchSuggestion)")[0];
				lc.insertBefore(aside,ref);
				if(0<$("aside+article li img").length){
					window.on("resize",asideCollide);
					window.requestAnimationFrame(asideCollide);
				}
		}}
		$(".search #searchTerm").on("input",getSuggestions).on("focus",searchFocus).on("blur",searchBlur).on("keydown",searchDown);
		$("button[data-check]").on("click",function checkBoxes(e){
			e.preventDefault();
			e.target.closest("fieldset,form").querySelectorAll("."+e.target.dataset.check).forEach(function check(c){
				c.checked=true;
			});
		});
		$("input,select").forEach(function checkInputValidityElement(i){
			i.on("input",checkInputValidity).on("invalid",displayValidityMessage);
		});
		$("textarea").forEach(setTextareaEvents);
		$("form").forEach(function testFormPresubmit(f){
			f.on("submit",testFormTextareas);
		});
		window.on("resize",function onResize(){
			$("iframe").forEach(sizeIframe);
		});
		$(articleHeadings).forEach(function formatArticleTitles(h){
			h.innerHTML=h.innerHTML[0]+h.innerHTML.substring(1).replace(matchCapsNoRepeats,"<span>$1</span>$2").replace(/:/gu,":<br/>");
		});
		if(inIframe()){
			document.documentElement.dataset.backgroundText=getTextFromElements(document,".comment>p");
			window.parent.postMessage("background-text","*");
			window.parent.postMessage("resize","*");
		}else{
			document.documentElement.classList.add("background-text");
			redoBackgroundText({data:"background-text"});
			window.on("message",redoBackgroundText);
		}
		window.requestAnimationFrame(function(){
			if(0<$("article>p>picture>img:not([data-swapped])").length){
				window.on("resize",swapImagesIfNoticeable);
			}
			window.requestAnimationFrame(swapImagesIfNoticeable);
		});
		setTimeout(eagerLoad, 5000);
	};
	isLoaded(document)||inIframe()?this.flush(true):window.on('load',this.flush);
})();
